clear;
clc;
%FILENAME = 'hall1.pgm';
FILENAME = 'ambassadors-skull.pgm'
%DATAFILE = 'hall1.dat';
DATAFILE = 'ambassadors-skull.dat'
DATA = load(DATAFILE);

image_coord = DATA(1:4, :);
real_coord = DATA(5:8, :);

A = [real_coord(1, 1) real_coord(1, 2) 1 0 0 0 -image_coord(1, 1)*real_coord(1, 1) -image_coord(1, 1)*real_coord(1, 2) -image_coord(1, 1);
    0 0 0 real_coord(1, 1) real_coord(1, 2) 1 -image_coord(1, 2)*real_coord(1, 1) -image_coord(1, 2)*real_coord(1, 2) -image_coord(1, 2);
    real_coord(2, 1) real_coord(2, 2) 1 0 0 0 -image_coord(2, 1)*real_coord(2, 1) -image_coord(2, 1)*real_coord(2, 2) -image_coord(2, 1);
    0 0 0 real_coord(2, 1) real_coord(2, 2) 1 -image_coord(2, 2)*real_coord(2, 1) -image_coord(2, 2)*real_coord(2, 2) -image_coord(2, 2);
    real_coord(3, 1) real_coord(3, 2) 1 0 0 0 -image_coord(3, 1)*real_coord(3, 1) -image_coord(3, 1)*real_coord(3, 2) -image_coord(3, 1);
    0 0 0 real_coord(3, 1) real_coord(3, 2) 1 -image_coord(3, 2)*real_coord(3, 1) -image_coord(3, 2)*real_coord(3, 2) -image_coord(3, 2);
    real_coord(4, 1) real_coord(4, 2) 1 0 0 0 -image_coord(4, 1)*real_coord(4, 1) -image_coord(4, 1)*real_coord(4, 2) -image_coord(4, 1);
    0 0 0 real_coord(4, 1) real_coord(4, 2) 1 -image_coord(4, 2)*real_coord(4, 1) -image_coord(4, 2)*real_coord(4, 2) -image_coord(4, 2)];

[U, S, V] = svd(A);
h = V(:, size(V, 2));

H = [h(1) h(2) h(3);
    h(4) h(5) h(6);
    h(7) h(8) h(9)];

disp('Input: image coordinates (bottom left to bottom right)')
image_coord
disp('Input: assumed world coordinates (bottom left to bottom right)')
real_coord

disp('Projective Matrix H:');
H

disp(['Loading image:', FILENAME]);
imfinfo(FILENAME)
IM = imread(FILENAME, 'PGM');
disp('Image loaded.');

figure(1)
image(gstocolor(IM))
title('Original Image')
axis off

disp('Applying transform');
new_image = apply_transform(inv(H), IM);

figure(2)
image(gstocolor(new_image))
title('Transformed Image');
axis off